#include "project.h"
#include "stdio.h"

//#define TRANSMIT_BUFFER_SIZE  16
void Dma_M_Tx_Configuration(void);
void Dma_M_Rx_Configuration(void);

/* DMA Configuration for DMA_TX_M */
#define DMA_TX_M_BYTES_PER_BURST       (1u)
#define DMA_TX_M_REQUEST_PER_BURST     (1u)
#define DMA_TX_M_SRC_BASE              (CYDEV_SRAM_BASE)
#define DMA_TX_M_DST_BASE              (CYDEV_PERIPH_BASE)

/* DMA Configuration for DMA_RX_M */
#define DMA_RX_M_BYTES_PER_BURST       (1u)
#define DMA_RX_M_REQUEST_PER_BURST     (1u)
#define DMA_RX_M_SRC_BASE              (CYDEV_PERIPH_BASE)
#define DMA_RX_M_DST_BASE              (CYDEV_SRAM_BASE)

#define TRANSMIT_BUFFER_SIZE  255    
#define SS_1 = 1;

/* Variable declarations for DMA_Tx_M */
uint8 M_TxChannel;
uint8 M_TxTD[2u];

/* Variable declarations for DMA_Rx_M */
uint8 M_RxChannel;
uint8 M_RxTD[2u];

/* Data to be transmitted by Tx */
uint8 m_txBuffer[TRANSMIT_BUFFER_SIZE];
uint8 m_rxBuffer[TRANSMIT_BUFFER_SIZE];
uint8 m_TX_Array[TRANSMIT_BUFFER_SIZE];


    
uint8 Datensatz = 100; /* ##############   Datensatz (+4 Instruktion!!!)  /anzahl################*/




char TransmitBuffer[TRANSMIT_BUFFER_SIZE];
char DataArray[TRANSMIT_BUFFER_SIZE];
char B_Zahler[TRANSMIT_BUFFER_SIZE];

uint8  sendRx[TRANSMIT_BUFFER_SIZE];   /*0x03 = READ Sequenze____Adress_0x00,0x00,0xAA*/    
uint8  sendTx[TRANSMIT_BUFFER_SIZE];   /*0x02 = Write Sequenze____Adress_0x00,0x00,0xAA*/ 


uint8  z=0;

int flag1=0;    /*Int for receive*/
int flag2=0;    /*Int for transmit*/


/*Int for transmit*/
CY_ISR(WakeupIsr1)
{
        flag1=1;
    
        SS_1_Write(0); 
        SPIM_PutArray(sendTx,(Datensatz+4));
        while(!(SPIM_ReadTxStatus() & SPIM_STS_SPI_DONE));
        SS_1_Write(1); 
        
        
        SPIM_ClearTxBuffer();
        SPIM_ClearRxBuffer(); 
        CyDelay(400u);        /*Delay for the Button*/     
}

/*Int for receive*/
CY_ISR(WakeupIsr2)
{
    flag2=1;
    
    SS_1_Write(0);
    SPIM_PutArray(sendRx,(Datensatz));
    while(!(SPIM_ReadTxStatus() & SPIM_STS_SPI_DONE));
    CyDelayUs(10);
    SPIM_ClearTxBuffer();
    SPIM_ClearRxBuffer(); 

    Dma_M_Rx_Configuration();
    CyDmaChEnable(M_RxChannel, 1u);
    
    while(!(SPIM_ReadTxStatus() & SPIM_STS_SPI_DONE));
    CyDelayUs(15);
    SS_1_Write(1); 
    CyDelay(1000u);        /*Delay for the Button*/ 
}



int main(void)
{        
    uint8 i = 0u;
    uint8 k = 0u;    
    
    CyGlobalIntEnable; 
    SW1_Pin_Int_StartEx(WakeupIsr1);    
    SW2_Pin_Int_StartEx(WakeupIsr2);
     
    SPIM_Start();
    LCD_Start();

 
    /*Configure Flash-options*/
    
       /*0xFF = Reset the I/O access from SRAM*/
       SS_1_Write(0);
       uint8  InstructionReset[1] = {0b11111111};  
       SPIM_PutArray(InstructionReset,sizeof(InstructionReset)); 
       while(!(SPIM_ReadTxStatus() & SPIM_STS_SPI_DONE));
       SS_1_Write(1);                                        
       SPIM_ClearTxBuffer();
    
    
        
       /*1.Byte = 0x01 => Write Mode Register (Mode-change) SRAM*/  
       /*2.Byte = 0x01 => Sequence mode continously-DATA transfer SRAM*/     
       SS_1_Write(0);
       uint8  InstructionWrite[2] = {0b00000001,0b01000000};       
       SPIM_PutArray(InstructionWrite,sizeof(InstructionWrite));   
       while(!(SPIM_ReadTxStatus() & SPIM_STS_SPI_DONE));
       SS_1_Write(1);                                        
       SPIM_ClearTxBuffer();

    
    
        /*Transmit simulation     0x00++ */ 
        k=0;
        for(i=4u; i<(Datensatz+4); i++)
        { 
        k++;
        sendTx[i] = k;
        }
        sendTx[0] = 0x02;
        sendTx[1] = 0x00;
        sendTx[2] = 0x00;
        sendTx[3] = 0xAA;
        k=0;  
 

    /*Wait for Read or Write*/ 
     while(1u)
    {
      LCD_ClearDisplay();
      LCD_Position(0u,0u);
      LCD_PrintString("push Button");
      CyDelay(300u);

    
    
       /*Write! Button Nr.1*/
        if(flag1==1)
         {
          flag1=0; 
          z++;
          SW1_Pin_ClearInterrupt();
         }  //Reset Send ISR
 
        
        
            
       /*Read! Button Nr. 2*/    
        if(flag2==1)
           { 
            flag2=0;
            SW2_Pin_ClearInterrupt();
           }   
    } 
}

    /*DMA-configuration for Transmit TX & Receive RX*/
/******************************************************************************************/

void Dma_M_Tx_Configuration(void)
{
    /* Init DMA, 1 byte bursts, each burst requires a request */ 
    M_TxChannel = DMA_TX_M_DmaInitialize(DMA_TX_M_BYTES_PER_BURST, DMA_TX_M_REQUEST_PER_BURST,  /**/
                                        HI16(DMA_TX_M_SRC_BASE), HI16(DMA_TX_M_DST_BASE));      /*SourceAdress, Destin.Adress*/

    M_TxTD[0u] = CyDmaTdAllocate(); /**/
    M_TxTD[1u] = CyDmaTdAllocate();

    /* Configure this Td chain as follows:
    *  - The TD is looping on itself
    *  - Increment the source address, but not the destination address   
    */
    CyDmaTdSetConfiguration(M_TxTD[0u], 1, M_TxTD[1u],TD_TERMOUT0_EN|TD_INC_SRC_ADR);  
    CyDmaTdSetConfiguration(M_TxTD[1u], 1, M_TxTD[0u],0);            
    
    /* From the memory to the SPIM */
    CyDmaTdSetAddress(M_TxTD[0u], LO16((uint32)m_txBuffer), LO16((uint32)SPIM_TXDATA_PTR));       
    CyDmaTdSetAddress(M_TxTD[1u], LO16((uint32)m_txBuffer), LO16((uint32)m_txBuffer));
    
    /* Associate the TD with the channel */
    CyDmaChSetInitialTd(M_TxChannel, M_TxTD[0u]); 
}    

/***************************************************************************/
void Dma_M_Rx_Configuration(void)
{ 
    /* Init DMA, 1 byte bursts, each burst requires a request */ 
    M_RxChannel = DMA_RX_M_DmaInitialize(DMA_RX_M_BYTES_PER_BURST, DMA_RX_M_REQUEST_PER_BURST,
                                     HI16(DMA_RX_M_SRC_BASE), HI16(DMA_RX_M_DST_BASE));

    M_RxTD[0u] = CyDmaTdAllocate();
    M_RxTD[1u] = CyDmaTdAllocate();

    
    CyDmaTdSetConfiguration(M_RxTD[0u], Datensatz, M_RxTD[1u], TD_TERMOUT0_EN|TD_INC_DST_ADR);
    CyDmaTdSetConfiguration(M_RxTD[1u], 1, M_RxTD[0u], 0u);

    /* From the SPIM to the memory */
    CyDmaTdSetAddress(M_RxTD[0u], LO16((uint32)SPIM_RXDATA_PTR), LO16((uint32)m_rxBuffer));
    CyDmaTdSetAddress(M_RxTD[1u], LO16((uint32)m_rxBuffer), LO16((uint32)m_rxBuffer));

    /* Associate the TD with the channel */
    CyDmaChSetInitialTd(M_RxChannel, M_RxTD[0u]);
}
   
	
/* [] END OF FILE */
